from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.level import Level
from bot_graphql.abc.query_abc import QueryABC


class LevelHistoryQuery(QueryABC):
    def __init__(self):
        QueryABC.__init__(self, "LevelHistory")

        self.set_field("id", self.resolve_id)
        self.set_field("name", self.resolve_name)
        self.set_field("color", self.resolve_color)
        self.set_field("minXp", self.resolve_min_xp)
        self.set_field("permissions", self.resolve_permissions)
        self.set_field("server", self.resolve_server)
        self.set_field("deleted", self.resolve_deleted)
        self.set_field("dateFrom", self.resolve_date_from)
        self.set_field("dateTo", self.resolve_date_to)

    @staticmethod
    def resolve_id(level: Level, *_):
        return level.id

    @staticmethod
    def resolve_name(level: Level, *_):
        return level.name

    @staticmethod
    def resolve_color(level: Level, *_):
        return level.color

    @staticmethod
    def resolve_min_xp(level: Level, *_):
        return level.min_xp

    @staticmethod
    def resolve_permissions(level: Level, *_):
        return level.permissions

    @staticmethod
    def resolve_server(level: Level, *_):
        return level.server

    @staticmethod
    def resolve_deleted(entry: HistoryTableABC, *_):
        return entry.deleted

    @staticmethod
    def resolve_date_from(entry: HistoryTableABC, *_):
        return entry.date_from

    @staticmethod
    def resolve_date_to(entry: HistoryTableABC, *_):
        return entry.date_to
